# Sample Code

Build instructions can be found at the top of each code file

`${LICENSE_CODE}` must be replaced with your license code.

### Face Recognition - 1 to 1 Identification
`face_recognition.cpp` demonstrates the usage of our face recognition API. A convinient method is provided that loads images, `setImage()`. This method can decode JPEG, BMP and PPM images.

`face_recognition_full_model.cpp` demonstrates the usage of our face recognition API, using the FULL model. This model has better accuracy, at the cost of 
increased inference time.

`face_recognition_image_buffer.cpp` uses the overloaded `setImage()` method that takes the pointer to a decoded image buffer in memory. 
The main usecase is processing frames grabed from a camera without writing them into a file.

### Face Recognition - 1 to N Identification
`identification.cpp` demonstrates the usage of our 1:N matcher. The `createDatabaseConnection` and `createLoadCollection` functions 
are first used to connect to an existing or new database, then create a new collection or populate data from an existing collection.
Next, templates are enrolled into the collection using the `enrollTemplate` function.
Finally, the collection can be queried using the `identifyTopCandidate` and `identifyTopCandidates` functions. Consult the header for 
other 1 to N functions. 

To save templates even after the application is terminated, change the `dbms` configuration option to a database option such as `SQLITE`

### Object Detection
`object_detection.cpp` demonstrates the usage of our object detector.

### Liveness
`blink_detection.cpp` demonstrates how to detect blinks, and can be used for liveness detection.

### Spoof Detection
`spoof_detection.cpp` demonstrates how to identify presentation attacks.

### Mask Detection
`detect_mask.cpp` demonstrates how to run mask detection on an image. Mask is detected when a user is wearing a face mask.

### Eye glasses Detection
`detect_eyeglasses.cpp` demonstrates how to run eye glasses detection on an image. Glasses are detected when a user is wearing some type of glasses.

### Batch Inference
`batch_fr_cuda.cpp` demonstrates how to generate face feature vectors in batch when using the GPU library.

### Live Streaming
There are many live streaming examples on our [Sample Apps Page](https://github.com/getchui/sample-apps) under `/cpp_sdk`
These require you to have OpenCV installed on your system. 
