# Sample code: Run spoof detection on two images (one real image, one spoofed image)

import tfsdk
import os

options = tfsdk.ConfigurationOptions()
# Can set configuration options here
# ex:
# options.smallest_face_height = 40
# options.fd_mode = tfsdk.FACEDETECTIONMODE.VERSATILE
# options.fd_filter = tfsdk.FACEDETECTIONFILTER.BALANCED
# options.fr_model = tfsdk.FACIALRECOGNITIONMODEL.FULL

sdk = tfsdk.SDK(options)

# TODO: export your license token as TRUEFACE_TOKEN environment variable
is_valid = sdk.set_license(os.environ['TRUEFACE_TOKEN'])
if (is_valid == False):
	print("Invalid License Provided")
	print("Be sure to export your license token as TRUEFACE_TOKEN")
	quit()

# Load the real image
res = sdk.set_image("../images/real.jpg")
if (res != tfsdk.ERRORCODE.NO_ERROR):
	print("Unable to set image 1")
	quit()

# Run spoof detection
res, spoof_label, spoof_score = sdk.detect_spoof()
if (res != tfsdk.ERRORCODE.NO_ERROR):
	print("Unable to run spoof with image 1")
	quit()

# Expect the result to be real
print("Real image predicted result:", spoof_label);

# Load the spoof atempt image
res = sdk.set_image("../images/fake.jpg")
if (res != tfsdk.ERRORCODE.NO_ERROR):
	print("Unable to set image 2")
	quit()

# Run spoof detection
res, spoof_label, spoof_score = sdk.detect_spoof()
if (res != tfsdk.ERRORCODE.NO_ERROR):
	print("Unable to run spoof with image 1")
	quit()

# Expect the result to be fake
print("Spoof attempt image predicted result:", spoof_label);
